
// The end of one block and the start of the next block will have the same connector
enum Connections {
    None,
    Start,
    End,

    RoadTechFlat,
    RoadTechDiagLeft,
    RoadTechDiagRight,
    RoadTechSlopeDown,
    RoadTechSlopeUp,
    RoadTechTiltLeft, // these connections are kinda weird since they don't line up with blocks directly. 
    RoadTechTiltRight,
    RoadTechInvertedBlack, // top of looping. Will only connect to another looping
    RoadTechInvertedWhite,

    RoadDirtFlat,
    RoadDirtDiagLeft,
    RoadDirtDiagRight,
    RoadDirtSlopeDown,
    RoadDirtSlopeUp,
    RoadDirtTiltLeft,
    RoadDirtTiltRight,
    RoadDirtInvertedBlack,
    RoadDirtInvertedWhite,

    RoadBumpFlat,
    RoadBumpDiagLeft,
    RoadBumpDiagRight,
    RoadBumpSlopeDown,
    RoadBumpSlopeUp,
    RoadBumpTiltLeft,
    RoadBumpTiltRight,
    RoadBumpInvertedBlack,
    RoadBumpInvertedWhite,

    RoadIceFlat,
    RoadIceFlatWallLeft,
    RoadIceFlatWallRight,
    RoadIceDiagLeft,
    RoadIceDiagLeftWallLeft,
    RoadIceDiagLeftWallRight,
    RoadIceDiagRight,
    RoadIceDiagRightWallLeft,
    RoadIceDiagRightWallRight,
    RoadIceSlopeDown,
    RoadIceSlopeUp,
    RoadIceTiltLeft,
    RoadIceTiltRight,
    RoadIceInvertedBlack,
    RoadIceInvertedWhite,

    RoadWaterFlat,
    TrackWallWaterFlat,
    TrackWallWaterReactorUp,

    SnowRoadFlat,
    SnowRoadSlopeDown,
    SnowRoadSlopeUp,
    SnowRoadTiltLeft,
    SnowRoadTiltRight,

    RallyCastleRoadFlat,
    RallyCastleRoadSlopeDown,
    RallyCastleRoadSlopeUp,
    RallyCastleRoadDiagLeft,
    RallyCastleRoadDiagRight,

    RallyRoadDirtHighFlat,
    RallyRoadDirtLowFlat,

    TrackWallFlat, // move down 1 when starting this
    TrackWallDiagLeft,
    TrackWallDiagRight,
    TrackWallSlopeDown,
    TrackWallSlopeUp,
    TrackWallTiltLeft,
    TrackWallTiltRight,

    Jump,
    JumpWhite,
    JumpBlack,
    
    PlatformTechFlat,
    PlatformTechSlopeDown,
    PlatformTechSlopeUp,
    PlatformTechTiltLeft, // height is 'lower'
    PlatformTechTiltRight,
    PlatformTechSlopeBaseLeft,
    PlatformTechSlopeBaseRight,
    PlatformTechSlopeBase2Left,
    PlatformTechSlopeBase2Right,
    PlatformTechSlopeStartLeft,
    PlatformTechSlopeStartRight,
    PlatformTechSlopeEndLeft,
    PlatformTechSlopeEndRight,
    PlatformTechLoopStartLeft,
    PlatformTechLoopStartRight,
    PlatformTechLoopOutStartLeft,
    PlatformTechLoopOutStartRight,
    PlatformTechSlope2UTop,
    PlatformTechSlope2UBottom,

    PlatformDirtFlat,
    PlatformDirtSlopeDown,
    PlatformDirtSlopeUp,
    PlatformDirtTiltLeft,
    PlatformDirtTiltRight,
    PlatformDirtSlopeBaseLeft,
    PlatformDirtSlopeBaseRight,
    PlatformDirtSlopeBase2Left,
    PlatformDirtSlopeBase2Right,
    PlatformDirtSlopeStartLeft,
    PlatformDirtSlopeStartRight,
    PlatformDirtSlopeEndLeft,
    PlatformDirtSlopeEndRight,
    PlatformDirtLoopStartLeft,
    PlatformDirtLoopStartRight,
    PlatformDirtLoopOutStartLeft,
    PlatformDirtLoopOutStartRight,
    PlatformDirtSlope2UTop,
    PlatformDirtSlope2UBottom,
    
    PlatformIceFlat,
    PlatformIceSlopeDown,
    PlatformIceSlopeUp,
    PlatformIceTiltLeft,
    PlatformIceTiltRight,
    PlatformIceSlopeBaseLeft,
    PlatformIceSlopeBaseRight,
    PlatformIceSlopeBase2Left,
    PlatformIceSlopeBase2Right,
    PlatformIceSlopeStartLeft,
    PlatformIceSlopeStartRight,
    PlatformIceSlopeEndLeft,
    PlatformIceSlopeEndRight,
    PlatformIceLoopStartLeft,
    PlatformIceLoopStartRight,
    PlatformIceLoopOutStartLeft,
    PlatformIceLoopOutStartRight,
    PlatformIceSlope2UTop,
    PlatformIceSlope2UBottom,
    
    PlatformGrassFlat,
    PlatformGrassSlopeDown,
    PlatformGrassSlopeUp,
    PlatformGrassTiltLeft,
    PlatformGrassTiltRight,
    PlatformGrassSlopeBaseLeft,
    PlatformGrassSlopeBaseRight,
    PlatformGrassSlopeBase2Left,
    PlatformGrassSlopeBase2Right,
    PlatformGrassSlopeStartLeft,
    PlatformGrassSlopeStartRight,
    PlatformGrassSlopeEndLeft,
    PlatformGrassSlopeEndRight,
    PlatformGrassLoopStartLeft,
    PlatformGrassLoopStartRight,
    PlatformGrassLoopOutStartLeft,
    PlatformGrassLoopOutStartRight,
    PlatformGrassSlope2UTop,
    PlatformGrassSlope2UBottom,
    
    PlatformPlasticFlat,
    PlatformPlasticSlopeDown,
    PlatformPlasticSlopeUp,
    PlatformPlasticTiltLeft,
    PlatformPlasticTiltRight,
    PlatformPlasticSlopeBaseLeft,
    PlatformPlasticSlopeBaseRight,
    PlatformPlasticSlopeBase2Left,
    PlatformPlasticSlopeBase2Right,
    PlatformPlasticSlopeStartLeft,
    PlatformPlasticSlopeStartRight,
    PlatformPlasticSlopeEndLeft,
    PlatformPlasticSlopeEndRight,
    PlatformPlasticLoopStartLeft,
    PlatformPlasticLoopStartRight,
    PlatformPlasticLoopOutStartLeft,
    PlatformPlasticLoopOutStartRight,
    PlatformPlasticSlope2UTop,
    PlatformPlasticSlope2UBottom,
    
    PlatformWaterFlat,

    DecoWallFlat,
    DecoWallSlopeDown,
    DecoWallSlopeUp,
    DecoWallTiltLeft,
    DecoWallTiltRight,
    DecoWallSlopeBaseLeft,
    DecoWallSlopeBaseRight,
    DecoWallSlopeBase2Left,
    DecoWallSlopeBase2Right,
    DecoWallSlopeStartLeft,
    DecoWallSlopeStartRight,
    DecoWallSlopeEndLeft,
    DecoWallSlopeEndRight,
    DecoWallLoopStartLeft,
    DecoWallLoopStartRight,
    DecoWallLoopOutStartLeft,
    DecoWallLoopOutStartRight,
    DecoWallSlope2UTop,
    DecoWallSlope2UBottom,

    DecoWallWaterFlat,
    DecoWallWaterToPlatformLeft,
    DecoWallWaterToPlatformRight,
    DecoWallWaterSlopeLeft,
    DecoWallWaterSlopeRight,
    DecoWallWaterSlopeDeepLeft,
    DecoWallWaterSlopeDeepRight,

    // used for jumping off stands
    PlatformTechTiltLeftToOpen,
    PlatformTechTiltRightToOpen,
    PlatformDirtTiltLeftToOpen,
    PlatformDirtTiltRightToOpen,
    PlatformIceTiltLeftToOpen,
    PlatformIceTiltRightToOpen,
    PlatformGrassTiltLeftToOpen,
    PlatformGrassTiltRightToOpen,


    OpenTechFlat,
    OpenTechSlopeDown,
    OpenTechSlopeUp,
    OpenTechTiltLeft,
    OpenTechTiltRight,
    OpenTechZoneLeftFlat,
    OpenTechZoneRightFlat,
    OpenTechZoneLeftSlopeDown,
    OpenTechZoneRightSlopeDown,
    OpenTechZoneLeftSlopeUp,
    OpenTechZoneRightSlopeUp,
    OpenTechZoneLeftTiltLeft,
    OpenTechZoneRightTiltLeft,
    OpenTechZoneLeftTiltRight,
    OpenTechZoneRightTiltRight,
    OpenTechHillShortLeft,
    OpenTechHillShortRight,

    OpenDirtFlat,
    OpenDirtSlopeDown,
    OpenDirtSlopeUp,
    OpenDirtTiltLeft,
    OpenDirtTiltRight,
    OpenDirtZoneLeftFlat,
    OpenDirtZoneRightFlat,
    OpenDirtZoneLeftSlopeDown,
    OpenDirtZoneRightSlopeDown,
    OpenDirtZoneLeftSlopeUp,
    OpenDirtZoneRightSlopeUp,
    OpenDirtZoneLeftTiltLeft,
    OpenDirtZoneRightTiltLeft,
    OpenDirtZoneLeftTiltRight,
    OpenDirtZoneRightTiltRight,
    OpenDirtHillShortLeft,
    OpenDirtHillShortRight,

    OpenDirtFlatGrass,
    OpenDirtSlopeDownGrass,
    OpenDirtSlopeUpGrass,

    OpenIceFlat,
    OpenIceSlopeDown,
    OpenIceSlopeUp,
    OpenIceTiltLeft,
    OpenIceTiltRight,
    OpenIceZoneLeftFlat,
    OpenIceZoneRightFlat,
    OpenIceZoneLeftSlopeDown,
    OpenIceZoneRightSlopeDown,
    OpenIceZoneLeftSlopeUp,
    OpenIceZoneRightSlopeUp,
    OpenIceZoneLeftTiltLeft,
    OpenIceZoneRightTiltLeft,
    OpenIceZoneLeftTiltRight,
    OpenIceZoneRightTiltRight,
    OpenIceHillShortLeft,
    OpenIceHillShortRight,

    OpenGrassFlat,
    OpenGrassSlopeDown,
    OpenGrassSlopeUp,
    OpenGrassTiltLeft,
    OpenGrassTiltRight,
    OpenGrassZoneLeftFlat,
    OpenGrassZoneRightFlat,
    OpenGrassZoneLeftSlopeDown,
    OpenGrassZoneRightSlopeDown,
    OpenGrassZoneLeftSlopeUp,
    OpenGrassZoneRightSlopeUp,
    OpenGrassZoneLeftTiltLeft,
    OpenGrassZoneRightTiltLeft,
    OpenGrassZoneLeftTiltRight,
    OpenGrassZoneRightTiltRight,
    OpenGrassHillShortLeft,
    OpenGrassHillShortRight,

    WaterGrassFlat,
    WaterGrassZoneLeftFlat,
    WaterGrassZoneRightFlat,
    WaterDirtFlat,
    WaterDirtZoneLeftFlat,
    WaterDirtZoneRightFlat,
    WaterIceFlat,
    WaterIceZoneLeftFlat,
    WaterIceZoneRightFlat,

    DecoPlatformFlat,
    DecoPlatformSlopeDown,
    DecoPlatformSlopeUp,
    DecoPlatformTiltLeft,
    DecoPlatformTiltRight,
    DecoPlatformSlopeBaseLeft,
    DecoPlatformSlopeBaseRight,
    DecoPlatformSlopeBase2Left,
    DecoPlatformSlopeBase2Right,
    DecoPlatformSlopeStartLeft,
    DecoPlatformSlopeStartRight,
    DecoPlatformSlopeEndLeft,
    DecoPlatformSlopeEndRight,
    DecoPlatformHillSlopeLeft,
    DecoPlatformHillSlopeRight,
    DecoPlatformSlope2UTop,
    DecoPlatformSlope2UBottom,

    DecoPlatformDirtFlat,
    DecoPlatformDirtSlopeDown,
    DecoPlatformDirtSlopeUp,
    DecoPlatformDirtTiltLeft,
    DecoPlatformDirtTiltRight,
    DecoPlatformDirtSlopeBaseLeft,
    DecoPlatformDirtSlopeBaseRight,
    DecoPlatformDirtSlopeBase2Left,
    DecoPlatformDirtSlopeBase2Right,
    DecoPlatformDirtSlopeStartLeft,
    DecoPlatformDirtSlopeStartRight,
    DecoPlatformDirtSlopeEndLeft,
    DecoPlatformDirtSlopeEndRight,
    DecoPlatformDirtHillSlopeLeft,
    DecoPlatformDirtHillSlopeRight,
    DecoPlatformDirtSlope2UTop,
    DecoPlatformDirtSlope2UBottom,

    DecoPlatformIceFlat,
    DecoPlatformIceSlopeDown,
    DecoPlatformIceSlopeUp,
    DecoPlatformIceTiltLeft,
    DecoPlatformIceTiltRight,
    DecoPlatformIceSlopeBaseLeft,
    DecoPlatformIceSlopeBaseRight,
    DecoPlatformIceSlopeBase2Left,
    DecoPlatformIceSlopeBase2Right,
    DecoPlatformIceSlopeStartLeft,
    DecoPlatformIceSlopeStartRight,
    DecoPlatformIceSlopeEndLeft,
    DecoPlatformIceSlopeEndRight,
    DecoPlatformIceHillSlopeLeft,
    DecoPlatformIceHillSlopeRight,
    DecoPlatformIceSlope2UTop,
    DecoPlatformIceSlope2UBottom,

    RoadToOpenTech,
    OpenTechToRoad,
    RoadToOpenDirt,
    OpenDirtToRoad,
    RoadToOpenIce,
    OpenIceToRoad,
    RoadToOpenGrass,
    OpenGrassToRoad,
    RoadToRallyRoadDirt,

    Structure,

    StandLeft, // driving over spectators
    StandRight,
    StagePlatform,
    StageLeft,
    StageRight,
    StageSupportPlatform,
    StageSupportLeft,
    StageSupportRight,
    StageInsideLeft,
    StageInsideRight,

    DropAny, // general 'dropping down onto something'
    PlatformAny, // changing platform material (unused currently)
// if adding new things to end, change list iterating in main
}

// Relative directions, for things that change depending on the orientation of a trackpiece
enum Directions {
    Forwards = 0,
    Left = 3,
    Right = 1,
    Reverse = 2,
}

// calculates the new absolute direction after being changed by a relative direction
CGameEditorPluginMap::ECardinalDirections AddDirections(CGameEditorPluginMap::ECardinalDirections a, Directions b) {
    switch (b) {
        case Directions::Forwards:
            return a;
        case Directions::Right:
            switch(a) {
            case CGameEditorPluginMap::ECardinalDirections::North:
                return CGameEditorPluginMap::ECardinalDirections::East;
            case CGameEditorPluginMap::ECardinalDirections::East:
                return CGameEditorPluginMap::ECardinalDirections::South;
            case CGameEditorPluginMap::ECardinalDirections::South:
                return CGameEditorPluginMap::ECardinalDirections::West;
            default:
                return CGameEditorPluginMap::ECardinalDirections::North;
            }
        case Directions::Left:
            switch(a) {
            case CGameEditorPluginMap::ECardinalDirections::North:
                return CGameEditorPluginMap::ECardinalDirections::West;
            case CGameEditorPluginMap::ECardinalDirections::East:
                return CGameEditorPluginMap::ECardinalDirections::North;
            case CGameEditorPluginMap::ECardinalDirections::South:
                return CGameEditorPluginMap::ECardinalDirections::East;
            default:
                return CGameEditorPluginMap::ECardinalDirections::South;
            }
        case Directions::Reverse:
            switch(a) {
            case CGameEditorPluginMap::ECardinalDirections::North:
                return CGameEditorPluginMap::ECardinalDirections::South;
            case CGameEditorPluginMap::ECardinalDirections::East:
                return CGameEditorPluginMap::ECardinalDirections::West;
            case CGameEditorPluginMap::ECardinalDirections::South:
                return CGameEditorPluginMap::ECardinalDirections::North;
            default:
                return CGameEditorPluginMap::ECardinalDirections::East;
            }
    }
    throw('All directions used');// this should never happen, but needed for compiling
    return CGameEditorPluginMap::ECardinalDirections::North;
}

// rotates a (relative) position to an absolute direction
// used for e.g. track section's end-location-from-start
int3 RotatePosition(int3 position, CGameEditorPluginMap::ECardinalDirections direction) {
    switch(direction) {
        case CGameEditorPluginMap::ECardinalDirections::North:
            return position;
        case CGameEditorPluginMap::ECardinalDirections::East:
            return int3(-position.z, position.y, position.x);
        case CGameEditorPluginMap::ECardinalDirections::South:
            return int3(-position.x, position.y, -position.z);
        default:
            return int3(position.z, position.y, -position.x);
    }

}

// properties a block can have. Used for calculating weights
enum Tags {
    //road
    RoadTech, 
    RoadDirt,
    RoadBump,
    RoadIce,
    RoadWater,
    SnowRoad,
    RallyCastleRoad,
    RallyRoadDirtHigh,
    RallyRoadDirtLow,
    RallyRoadDirt, // average
    TrackWall,
    TrackWallWater,
    PlatformTech,
    PlatformDirt,
    PlatformIce,
    PlatformGrass,
    PlatformPlastic,
    PlatformWater,
    DecoWall,
    DecoWallWater,
    // platform-path
    OpenTech, 
    OpenDirt,
    OpenIce,
    OpenGrass,
    WaterGrass,
    WaterDirt,
    WaterIce,
    PenaltyGrass,
    PenaltySand,
    PenaltySnow,
    Structure,
    Stand,// driving over spectators
    Stage,
    StagePlatform,
    StageSupport,
    StageSupportPlatform,
    StageInside,

    Corner,
    Flat,
    Slope,
    Tilt,
    Diagonal,
    Loop,

    // extra unused exits
    Junction,
    ChangeMaterial,
    NoDuplicate, // 2 blocks with this tag can't be put after each other
    ChangeBorder,
    ChangeSlope,
    ChangeTilt,
    // change slope and change tilt but as one
    ChangeAngle,
    SideConnection,

    Start,
    Checkpoint,
    Multilap,
    Finish,
    FakeFinish,
    Hole,
    PenaltyRoad,
    Ramp,
    AntiRamp,
    Bump,
    Narrow,
    IceWall,
    IceWallChange,
    Poles,
    JumpStart,
    DropJumpStart,
    JumpContinue,

    Turbo,
    AntiTurbo,
    SuperTurbo,
    AntiSuperTurbo,
    RandomTurbo,
    AntiRandomTurbo,
    BoostUp,
    BoostDown,
    Boost2Up,
    Boost2Down,
    Cruise,
    NoBrake,
    NoEngine,
    NoSteering,
    SlowMotion,
    Fragile,
    Reset,

    CarStadium,
    CarSnow,
    CarRally,

    PreviousNotEmpty,

    Quarter,
    Half,
    Double,
    HighChance,
}


bool int3Equals(int3 a, int3 b) {
    if (a.x == b.x && a.y == b.y && a.z == b.z) {
        return true;
    } return false;
}

/* Stores the data about a block placement. 
 * includes orientation, connectors, end position
 * ingame blocks can have multiple Blocks for them, such as a corner having left and right variants */
class Block {
    // string name that identifies block ingame
    string NameID;
    Connections startConnector;
    Connections endConnector;
    // the position of the end of the block section, relative to the start
    int3 endPosition; // size-1 block is (0,0,1), corner2 is (+-1,0,2))
    // end direction relative to start
    Directions Direction;
    // tags applicable to this block
    array<Tags> tags;
    // approximate length (integer rounded)
    uint length;
    // rotation of the actual block relative to the direction the generation starts from
    Directions RotationOffset;
    /* the position the block will be placed relative to the connection start point.
    different version for every rotation */
    array<int3> PositionOffset(4);

    Block(const string &in NameID, Connections startConnector, Connections endConnector, int3 endPosition, Directions Direction,
    array<Tags> tags, uint length, Directions RotationOffset = Directions::Forwards, array<int3> PositionOffset = {int3(0,0,1),int3(-1,0,0),int3(0,0,-1),int3(1,0,0)}) {
        this.NameID = NameID;
        this.startConnector = startConnector;
        this.endConnector = endConnector;
        this.endPosition = endPosition;
        this.Direction = Direction;
        this.tags = tags;
        this.length = length;
        this.RotationOffset = RotationOffset;
        this.PositionOffset = PositionOffset;
        if (PositionOffset.Length != 4){
            throw('wrong positionoffset');
        }
    }
    Block(const string &in NameID, Connections startConnector, Connections endConnector, int3 endPosition, Directions Direction,
    array<Tags> tags, uint length, array<int3> PositionOffset) {
        this.NameID = NameID;
        this.startConnector = startConnector;
        this.endConnector = endConnector;
        this.endPosition = endPosition;
        this.Direction = Direction;
        this.tags = tags;
        this.length = length;
        this.RotationOffset = Directions::Forwards;
        this.PositionOffset = PositionOffset;
        if (PositionOffset.Length != 4){
            throw('wrong positionoffset');
        }
    }
    // needed for compile, but Block should never be created without arguments
    // Block() {throw("Don't use Block default constructor");}
}
